// Plugin demo pour XnView
// Antonio Da Cruz - 26/1/2007
// Actions simples via l'explorateur XnView

unit Params;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, XPlugins, ComCtrls, ExtCtrls;

type
  TFrmParams = class(TForm)
    ButtonOk: TButton;
    Label1: TLabel;
    LstFiles: TListView;
    ActionGroup: TRadioGroup;
    ButtonCancel: TButton;
    procedure ButtonOkClick(Sender: TObject);
  private
    Files: array of TPLUGIN_FILELIST;
    pParams: PPLUGIN_PARAMS;
    function GetDestName(FileName: PChar): PChar;
    procedure ActionBitmap(FileName: PChar);
  public
    procedure InitData(var FileList: TPLUGIN_FILELIST; FileCount: LongInt;
      var Params: TPLUGIN_PARAMS);
  end;

var
  FrmParams: TFrmParams;

implementation

{$R *.dfm}

// Charge la liste des fichiers
procedure TFrmParams.InitData(var FileList: TPLUGIN_FILELIST;
  FileCount: LongInt; var Params: TPLUGIN_PARAMS);
var
  I: Integer;
begin
  Files := @FileList.FileName;
  LstFiles.Items.BeginUpdate;
  for I := 0 to FileCount - 1 do
    with LstFiles.Items.Add do
    begin
      Caption := ExtractFileName(Files[I].FileName);
      Checked := True;
    end;
  LstFiles.Items.EndUpdate;
  pParams := @Params;
end;

function TFrmParams.GetDestName(FileName: PChar): PChar;
begin
  Result := PChar(ChangeFileExt(FileName, '') + '(r90).jpg');
end;

procedure TFrmParams.ActionBitmap(FileName: PChar);
var
  pBitmap: PLUGIN_BITMAP;
  SaveParams: PLUGIN_SAVE_PARAMS;
begin
	if not pParams.LoadBitmap(FileName, pBitmap) then
  begin
    ShowMessage('Erreur lors de l''ouverture de ' + FileName);
    Exit;
  end;

  try
    case ActionGroup.ItemIndex of
      0: pParams.Rotate(pBitmap, 90, Ord(True));
      1: pParams.Rotate(pBitmap, -90, Ord(True));
    end;

    pParams.SaveBitmap(GetDestName(FileName), 'jpeg', pBitmap, SaveParams);
  finally
    pParams.FreeBitmap(pBitmap);
  end;
end;

procedure TFrmParams.ButtonOkClick(Sender: TObject);
var
  I: Integer;
begin
  for I := 0 to LstFiles.Items.Count - 1 do
    if LstFiles.Items[I].Checked then
      ActionBitmap(Files[I].FileName);
end;

end.
