// Plugin demo pour XnView
// Antonio Da Cruz - 8/1/2007

unit Params;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, XPlugins, ExtCtrls;

type
  TFrmParams = class(TForm)
    Button1: TButton;
    FilterGroup: TRadioGroup;
    procedure Button1Click(Sender: TObject);
  private
    pParams: PPLUGIN_PARAMS;
  public
    procedure InitParam(TheParams: PPLUGIN_PARAMS);
    procedure DoFilter;
  end;

var
  FrmParams: TFrmParams;

implementation

{$R *.dfm}

procedure TFrmParams.InitParam(TheParams: PPLUGIN_PARAMS);
begin
  pParams := TheParams;
end;

procedure TFrmParams.DoFilter;
var
  pBitmap: PLUGIN_BITMAP;
begin
  // rcupre le contenu de la slection
  pBitmap := pParams.GetBitmapSelection;

  // Teste le chargement
  if pBitmap = nil then
  begin
    ShowMessage('Error loading bitmap selection !');
    pParams.FreeBitmap(pBitmap);
    Exit;
  end;

  try
    case FilterGroup.ItemIndex of
      0: pParams.Adjust(pBitmap, 0, 0, 2.0);
      1: pParams.Sharpen(pBitmap, 80);
      2: pParams.Blur(pBitmap, 80);
      3: pParams.Rotate(pBitmap, 90, Ord(True));
      4: pParams.Rotate(pBitmap, -90, Ord(True));
    end;

    pParams.SetBitmapSelection(pBitmap);
  finally
    pParams.FreeBitmap(pBitmap);
  end;
end;

procedure TFrmParams.Button1Click(Sender: TObject);
begin
  DoFilter;
end;

end.
