//
//                        XPlugins.h
//
//  XnView Copyright (c) 1998-2007 Pierre-e Gougelet
//  All rights reserved
//
//
//
// Mise  jour :
// 6/1/2007 : Antonio da Cruz
// 1/2/2007 : Antonio da Cruz

unit XPlugins;

interface

uses windows;
{$ALIGN ON} // Aligned record fields

const PLUGIN_VERSION = $0200;

type
  PPLUGIN_COLOR = ^TPLUGIN_COLOR;
  TPLUGIN_COLOR = record
    red: Byte;
    green: Byte;
    blue: Byte;
    alpha: Byte;
  end;

//type PPLUGIN_FILELIST = ^TPLUGIN_FILELISTR;
type
  PPLUGIN_FILELIST = ^TPLUGIN_FILELIST;
  TPLUGIN_FILELIST = record
	  filename: array[0..259] of char;
  end;

type
  PPLUGIN_SAVE_PARAMS = ^TPLUGIN_SAVE_PARAMS;
  TPLUGIN_SAVE_PARAMS = record
	  removeMetadata: LongInt;
   	jpegQuality: LongInt;
	  pngLevel: LongInt;
  end;

type PLUGIN_BITMAP = Pointer;
type PLUGIN_METADATA = Pointer;

type PLUGIN_BITMAP_TYPE = LongInt;
const PLUGIN_BITMAP_BINARY = 0;
const PLUGIN_BITMAP_COLORS = 1;
const PLUGIN_BITMAP_GREYSCALE = 2;
const PLUGIN_BITMAP_RGB = 3;
const PLUGIN_BITMAP_RGBA = 4;

// Format name available:
//		jpeg, bmp, png
//
const PLUGIN_RESIZE_ORIENTATION = $01;
const PLUGIN_RESIZE_KEEPRATIO = $02;

type
  PLUGIN_SAVE_PARAMS = record
		removeMetadata: Integer;
		jpegQuality: Integer;
		pngLevel: Integer;
  end;

type
  TLanguageArray = array[0..7] of Char; // type obligatoire
  TLutArray = array[0..255] of Char;
  TPLUGIN_FILTER = record
    size: Integer;
    matrix: array[0..6, 0..6] of Integer;
    divisor: Integer;
    bias: Integer;
  end;

	TGetLanguage = procedure (language: TLanguageArray); stdcall;
	TGetPathnameForINI = procedure (pPathname: PChar); stdcall;
  TGetXnViewPathname = procedure (pathname: PChar; filename_length: LongInt);
  TGetXnViewBasePathname = procedure (pathname: PChar; filename_length: LongInt);
  TGetXnViewAddonPathname = procedure (pathname: PChar; filename_length: LongInt);
  TGetFolder = function (hDlg: HWND; pathname: PChar; filename_length: LongInt): BOOL;
  TGetOutputFilename = function (hDlg: HWND; base_pathname: PChar; extension: PChar; pathname: PChar; filename_length: LongInt): BOOL;

	TGetThumbnail = function (filename: PChar; max_width: LongInt; max_height: LongInt): HBITMAP; stdcall;
	TFreeThumbnail = procedure (hBitmap: HBITMAP); stdcall;
	TLoadDIB = function (filename: PChar): HBITMAP; stdcall;
	TLoadDIBEx = function (filename: PChar; var metadata: PLUGIN_BITMAP; format_name: PChar; format_name_length: LongInt): HBITMAP; stdcall;
	TBitmapToDIB = function (bitmap: PLUGIN_BITMAP): HBITMAP; stdcall;
	TSaveDIB = function (filename: PChar; format_name: PChar; hBitmap: HBITMAP; var save_params: PLUGIN_SAVE_PARAMS): BOOL; stdcall;
	TSaveDIBEx = function (filename: PChar; format_name: PChar; hBitmap: HBITMAP; metadata: PLUGIN_METADATA; var save_params: PLUGIN_SAVE_PARAMS): BOOL; stdcall;
	TFreeMetadata = procedure (metadata: PLUGIN_METADATA); stdcall;

	TGetBitmapInfo = function (filename: PChar; var width: LongInt; var height: LongInt; format_name: PChar; format_name_length: LongInt): BOOL; stdcall;
	TLoadBitmap = function (filename: PChar; var bitmap: PLUGIN_BITMAP): BOOL; stdcall;
	TLoadBitmapEx = function (filename: PChar; var bitmap: PLUGIN_BITMAP; format_name: PChar; format_name_length: LongInt): BOOL; stdcall;
	TSaveBitmap = function (filename: PChar; format_name: PChar; bitmap: PLUGIN_BITMAP; var save_params: PLUGIN_SAVE_PARAMS): BOOL; stdcall;
	TFreeBitmap = procedure (bitmap: PLUGIN_BITMAP); stdcall;

	TBitmapGetType = function (bitmap: PLUGIN_BITMAP): PLUGIN_BITMAP_TYPE; stdcall;
	TBitmapGetWidth = function (bitmap: PLUGIN_BITMAP): Integer; stdcall;
	TBitmapGetHeight = function (bitmap: PLUGIN_BITMAP): Integer; stdcall;
	TBitmapGetBits = function (bitmap: PLUGIN_BITMAP): Integer; stdcall;
	TBitmapGetBytesPerLine = function (bitmap: PLUGIN_BITMAP): Integer; stdcall;

  // -- Only for filter plugin...
  TBitmapGetBuffer = function (bitmap: PLUGIN_BITMAP; y: Integer): Pointer; stdcall;// RGB/RGBA
  TBitmapNew = function (width, height: Integer; atype: PLUGIN_BITMAP_TYPE): PLUGIN_BITMAP; stdcall;
  TGetBitmapFilename = procedure (pathname: PChar; filename_length: Integer); stdcall;
  TBitmapCopy = function (bitmap: PLUGIN_BITMAP; const org_bitmap: PLUGIN_BITMAP): BOOL; stdcall;
  TGetBitmap = function: PLUGIN_BITMAP; stdcall;
  TGetBitmapSelection = function: PLUGIN_BITMAP; stdcall;
  TGetSelection = function (var rect: TRect): BOOL; stdcall;
  TSetBitmap = function (bitmap: PLUGIN_BITMAP): BOOL; stdcall;
  TSetBitmapSelection = function (bitmap: PLUGIN_BITMAP): BOOL; stdcall;
  TGetDIB = function: HBITMAP; stdcall;
  TGetDIBSelection = function: HBITMAP; stdcall;
  TSetDIB = function (hBitmap: HBITMAP): BOOL; stdcall;
  TSetDIBSelection = function (hBitmap: HBITMAP): BOOL; stdcall;

	TBitmapGetIPTC = function (bitmap: PLUGIN_BITMAP; id: UINT): PChar; stdcall;
	TBitmapGetEXIF = function (bitmap: PLUGIN_BITMAP; tag: UINT): PChar; stdcall;
	TFree = procedure (ptr: Pointer); stdcall;

	TResize = function (bitmap: PLUGIN_BITMAP; width: LongInt; height: LongInt; flag: UINT): BOOL; stdcall;
  TCanvasResize = function (bitmap: PLUGIN_BITMAP; width: LongInt; height: LongInt; var color: TPLUGIN_COLOR): BOOL; stdcall;
	TRotate = function (bitmap: PLUGIN_BITMAP; degrees: LongInt; smooth: LongInt): BOOL; stdcall;
  TFlipVertical = function (bitmap: PLUGIN_BITMAP): BOOL; stdcall;
  TFlipHorizontal = function (bitmap: PLUGIN_BITMAP): BOOL; stdcall;

	TAdjust = function (bitmap: PLUGIN_BITMAP; brightness: LongInt; contrast: LongInt; gamma: double): BOOL; stdcall;
  TAdjustHLS = function (bitmap: PLUGIN_BITMAP; hue, lightness, saturation: Integer): BOOL; stdcall;
  TApplyLut = function (bitmap: PLUGIN_BITMAP; lut: TLutArray): BOOL; stdcall;
  TConvolve = function (bitmap: PLUGIN_BITMAP; var Filter: TPLUGIN_FILTER): BOOL; stdcall; //  voir si var ou pointeur
  TBlur = function (bitmap: PLUGIN_BITMAP; percent: Integer): BOOL; stdcall;
	TSharpen = function (bitmap: PLUGIN_BITMAP; percent: LongInt): BOOL; stdcall;
	TCrop = function (bitmap: PLUGIN_BITMAP; x: LongInt; y: LongInt; w: LongInt; h: LongInt): BOOL; stdcall;
	TConvertInRGB = function (bitmap: PLUGIN_BITMAP): BOOL; stdcall;
	TConvertInColors = function (bitmap: PLUGIN_BITMAP): BOOL; stdcall;

  PPLUGIN_PARAMS = ^TPLUGIN_PARAMS;
  TPLUGIN_PARAMS = record
	  structSize: LongInt;
    hInstance: THandle;
	  hWnd: HWND;

   	GetLanguage: TGetLanguage;
   	GetPathnameForINI: TGetPathnameForINI;
    //GetFilename: Pointer;
    GetXnViewPathname: TGetXnViewPathname;
    GetXnViewBasePathname: TGetXnViewBasePathname;
    GetXnViewAddonPathname: Pointer;
    GetFolder: TGetFolder;
    GetOutputFilename: Pointer; 

   	GetThumbnail: TGetThumbnail;
   	FreeThumbnail: TFreeThumbnail;
    LoadDIB: TLoadDIB;
    LoadDIBEx: TLoadDIBEx;
    BitmapToDIB: TBitmapToDIB;
    SaveDIB: TSaveDIB;
    SaveDIBEx: TSaveDIBEx;
    FreeMetadata: TFreeMetadata;

    GetBitmapInfo: TGetBitmapInfo;
	  LoadBitmap: TLoadBitmap;
	  LoadBitmapEx: TLoadBitmapEx;    
	  SaveBitmap: TSaveBitmap;
   	FreeBitmap: TFreeBitmap;

	  BitmapGetType: TBitmapGetType;
	  BitmapGetWidth: TBitmapGetWidth;
   	BitmapGetHeight: TBitmapGetHeight;
	  BitmapGetBits: TBitmapGetBits;
	  BitmapGetBytesPerLine: TBitmapGetBytesPerLine;

    // -- Only for filter plugin...
    BitmapGetBuffer: TBitmapGetBuffer;
    BitmapNew: TBitmapNew;
    GetBitmapFilename: TGetBitmapFilename;
    BitmapCopy: TBitmapCopy;
    GetBitmap: TGetBitmap;
    GetBitmapSelection: TGetBitmapSelection;
    GetSelection: TGetSelection;
    SetBitmap: TSetBitmap;
    SetBitmapSelection: TSetBitmapSelection;
    GetDIB: TGetDIB;
    GetDIBSelection: TGetDIBSelection;
    SetDIB: TSetDIB;
    SetDIBSelection: TSetDIBSelection;

	  BitmapGetIPTC: TBitmapGetIPTC;
	  BitmapGetEXIF: TBitmapGetEXIF;
	  Free: TFree;

	  Resize: TResize;
    CanvasResize: TCanvasResize;
   	Rotate: TRotate;
    FlipVertical: TFlipVertical;
    FlipHorizontal: TFlipHorizontal;
	  Adjust: TAdjust;
    AdjustHLS: TAdjustHLS;
    ApplyLut: TApplyLut;
    Convolve: TConvolve;
    Blur: TBlur;
   	Sharpen: TSharpen;
	  Crop: TCrop;
	  ConvertInRGB: TConvertInRGB;
	  ConvertInColors: TConvertInColors;
  end;


const PLUGIN_CAP_ERROR = $8000;
const PLUGIN_CAP_NORMAL = $0000;
const PLUGIN_CAP_ACCEPT_FILES = $0001;
const PLUGIN_CAP_ACCEPT_FOLDERS = $0002;
const PLUGIN_CAP_FILTER = $0004;

const PLUGIN_HEADER_STRING_LENGTH = 256;

type
  PPLUGIN_HEADER = ^TPLUGIN_HEADER;
  TPLUGIN_HEADER = record
	  structSize: LongInt;
    description: array[0..PLUGIN_HEADER_STRING_LENGTH-1] of char; // or label
	  author: array[0..PLUGIN_HEADER_STRING_LENGTH-1] of char;
	  version: array[0..PLUGIN_HEADER_STRING_LENGTH-1] of char;
	  comment: array[0..PLUGIN_HEADER_STRING_LENGTH-1] of char;
  	capabilities: UINT;
	  hIcon: HICON;
  end;

implementation

end.
