unit Params;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, XPlugins;

type
  TFrmParams = class(TForm)
    Button1: TButton;
    LstFiles: TListBox;
    Label1: TLabel;
    LblTaille: TLabel;
    procedure LstFilesClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    pParams: PPLUGIN_PARAMS;
    pBitmap: PLUGIN_BITMAP;
    procedure LoadBitmap(FileName: PChar);
  public
    procedure InitData(var FileList: TPLUGIN_FILELIST; FileCount: LongInt;
      var Params: TPLUGIN_PARAMS);
  end;

var
  FrmParams: TFrmParams;

implementation

{$R *.dfm}

procedure TFrmParams.FormCreate(Sender: TObject);
begin
  LblTaille.Caption := '';
end;

procedure TFrmParams.InitData(var FileList: TPLUGIN_FILELIST;
  FileCount: LongInt; var Params: TPLUGIN_PARAMS);
var
  I: Integer;
  Files: array of TPLUGIN_FILELIST;
begin
  Files := @FileList.FileName;
  for I := 0 to FileCount - 1 do
    LstFiles.Items.Add(Files[I].FileName);
  pParams := @Params;
end;

procedure TFrmParams.LstFilesClick(Sender: TObject);
begin
  LoadBitmap(PChar(LstFiles.Items[LstFiles.ItemIndex]));
end;

procedure TFrmParams.LoadBitmap(FileName: PChar);
begin
	if not pParams.LoadBitmap(FileName, pBitmap) then
  begin
    LblTaille.Caption := '';
    ShowMessage('Problem when opening ' + FileName);
    Exit;
  end;
  LblTaille.Caption := Format('%dx%d %d bit', [pParams.BitmapGetWidth(pBitmap),
    pParams.BitmapGetHeight(pBitmap), pParams.BitmapGetBits(pBitmap)]);

  // effectuer ici le traitement sur le bitmap
  pParams.FreeBitmap(pBitmap);
end;

end.
